#include "finrecipes.h"

#define int_dll  __declspec(dllexport) int __stdcall
#define void_dll  __declspec(dllexport) void  __stdcall
#define double_dll __declspec(dllexport) double __stdcall

extern "C" { 
	double_dll random_uniform_0_1_dll(void){return random_uniform_0_1() ;} 
	double_dll option_price_call_black_scholes_dll(const double& S,     // spot price
					     const double& K,     // Strike (exercise) price,
					     const double& r,     // interest rate
					     const double& sigma, // volatility
					     const double& time){  return option_price_call_black_scholes( S,     
					      K,     
					      r,      
					      sigma, 
					      time);}
	double_dll option_price_implied_volatility_call_black_scholes_bisections_dll(const double& S,
								     const double& K,
								     const double& r,
								     const double& time,
									 const double& option_price){return						option_price_implied_volatility_call_black_scholes_bisections(S,K,r,time,option_price);}
									 	double_dll option_price_implied_volatility_call_black_scholes_newton_dll(const double& S,
								     const double& K,
								     const double& r,
								     const double& time,
									 const double& option_price){return						option_price_implied_volatility_call_black_scholes_newton(S,K,r,time,option_price);}
	double_dll heston_call_option_price_dll(const double& S, const double& K, const double& r, const double& v,
				const double& tau, const double& rho,  const double& kappa, 
				const double& lambda,  const double& theta, const double& sigma){return 
				heston_call_option_price(S, K, r, v, 
				tau, rho,  kappa, 
				lambda,  theta, sigma) ;}	
	//double_dll random_uniform_0_1(void){return finrecipes::random_uniform_0_1() ;} 
	//int_dll main(){return finum::main() ;} 
}

